Index: trunk/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -48,7 +48,4 @@
 TComPic::TComPic()
 : m_uiTLayer                              (0)
-#if SVC_EXTENSION
-, m_layerId( 0 )
-#endif
 , m_bUsedByCurr                           (false)
 , m_bIsLongTerm                           (false)
@@ -59,13 +56,8 @@
 , m_bNeededForOutput                      (false)
 , m_uiCurrSliceIdx                        (0)
-#if !HM_CLEANUP_SAO
-, m_pSliceSUMap                           (NULL)
-, m_pbValidSlice                          (NULL)
-, m_sliceGranularityForNDBFilter          (0)
-, m_bIndependentSliceBoundaryForNDBFilter (false)
-, m_bIndependentTileBoundaryForNDBFilter  (false)
-, m_pNDBFilterYuvTmp                      (NULL)
-#endif
 , m_bCheckLTMSB                           (false)
+#if SVC_EXTENSION
+, m_layerId( 0 )
+#endif
 {
 #if SVC_EXTENSION
@@ -214,5 +206,5 @@
   } 
 }
-#if HM_CLEANUP_SAO
+
 Bool  TComPic::getSAOMergeAvailability(Int currAddr, Int mergeAddr)
 {
@@ -221,341 +213,4 @@
   return (mergeCtbInSliceSeg && mergeCtbInTile);
 }
-#else
-/** Create non-deblocked filter information
- * \param pSliceStartAddress array for storing slice start addresses
- * \param numSlices number of slices in picture
- * \param sliceGranularityDepth slice granularity 
- * \param bNDBFilterCrossSliceBoundary cross-slice-boundary in-loop filtering; true for "cross".
- * \param numTiles number of tiles in picture
- * \param bNDBFilterCrossTileBoundary cross-tile-boundary in-loop filtering; true for "cross".
- */
-Void TComPic::createNonDBFilterInfo(std::vector<Int> sliceStartAddress, Int sliceGranularityDepth
-                                    ,std::vector<Bool>* LFCrossSliceBoundary
-                                    ,Int numTiles
-                                    ,Bool bNDBFilterCrossTileBoundary)
-{
-  UInt maxNumSUInLCU = getNumPartInCU();
-  UInt numLCUInPic   = getNumCUsInFrame();
-#if REPN_FORMAT_IN_VPS
-  UInt picWidth      = getSlice(0)->getPicWidthInLumaSamples();
-  UInt picHeight     = getSlice(0)->getPicHeightInLumaSamples();
-#else
-  UInt picWidth      = getSlice(0)->getSPS()->getPicWidthInLumaSamples();
-  UInt picHeight     = getSlice(0)->getSPS()->getPicHeightInLumaSamples();
-#endif
-  Int  numLCUsInPicWidth = getFrameWidthInCU();
-  Int  numLCUsInPicHeight= getFrameHeightInCU();
-  UInt maxNumSUInLCUWidth = getNumPartInWidth();
-  UInt maxNumSUInLCUHeight= getNumPartInHeight();
-  Int  numSlices = (Int) sliceStartAddress.size() - 1;
-  m_bIndependentSliceBoundaryForNDBFilter = false;
-  if(numSlices > 1)
-  {
-    for(Int s=0; s< numSlices; s++)
-    {
-      if((*LFCrossSliceBoundary)[s] == false)
-      {
-        m_bIndependentSliceBoundaryForNDBFilter = true;
-      }
-    }
-  }
-  m_sliceGranularityForNDBFilter = sliceGranularityDepth;
-  m_bIndependentTileBoundaryForNDBFilter  = (bNDBFilterCrossTileBoundary)?(false) :((numTiles > 1)?(true):(false));
-
-  m_pbValidSlice = new Bool[numSlices];
-  for(Int s=0; s< numSlices; s++)
-  {
-    m_pbValidSlice[s] = true;
-  }
-  m_pSliceSUMap = new Int[maxNumSUInLCU * numLCUInPic];
-
-  //initialization
-  for(UInt i=0; i< (maxNumSUInLCU * numLCUInPic); i++ )
-  {
-    m_pSliceSUMap[i] = -1;
-  }
-  for( UInt CUAddr = 0; CUAddr < numLCUInPic ; CUAddr++ )
-  {
-    TComDataCU* pcCU = getCU( CUAddr );
-    pcCU->setSliceSUMap(m_pSliceSUMap + (CUAddr* maxNumSUInLCU)); 
-    pcCU->getNDBFilterBlocks()->clear();
-  }
-  m_vSliceCUDataLink.clear();
-
-  m_vSliceCUDataLink.resize(numSlices);
-
-  UInt startAddr, endAddr, firstCUInStartLCU, startLCU, endLCU, lastCUInEndLCU, uiAddr;
-  UInt LPelX, TPelY, LCUX, LCUY;
-  UInt currSU;
-  UInt startSU, endSU;
-
-  for(Int s=0; s< numSlices; s++)
-  {
-    //1st step: decide the real start address
-    startAddr = sliceStartAddress[s];
-    endAddr   = sliceStartAddress[s+1] -1;
-
-    startLCU            = startAddr / maxNumSUInLCU;
-    firstCUInStartLCU   = startAddr % maxNumSUInLCU;
-
-    endLCU              = endAddr   / maxNumSUInLCU;
-    lastCUInEndLCU      = endAddr   % maxNumSUInLCU;   
-
-    uiAddr = m_apcPicSym->getCUOrderMap(startLCU);
-
-    LCUX      = getCU(uiAddr)->getCUPelX();
-    LCUY      = getCU(uiAddr)->getCUPelY();
-    LPelX     = LCUX + g_auiRasterToPelX[ g_auiZscanToRaster[firstCUInStartLCU] ];
-    TPelY     = LCUY + g_auiRasterToPelY[ g_auiZscanToRaster[firstCUInStartLCU] ];
-    currSU    = firstCUInStartLCU;
-
-    Bool bMoveToNextLCU = false;
-    Bool bSliceInOneLCU = (startLCU == endLCU);
-
-    while(!( LPelX < picWidth ) || !( TPelY < picHeight ))
-    {
-      currSU ++;
-
-      if(bSliceInOneLCU)
-      {
-        if(currSU > lastCUInEndLCU)
-        {
-          m_pbValidSlice[s] = false;
-          break;
-        }
-      }
-
-      if(currSU >= maxNumSUInLCU )
-      {
-        bMoveToNextLCU = true;
-        break;
-      }
-
-      LPelX = LCUX + g_auiRasterToPelX[ g_auiZscanToRaster[currSU] ];
-      TPelY = LCUY + g_auiRasterToPelY[ g_auiZscanToRaster[currSU] ];
-
-    }
-
-
-    if(!m_pbValidSlice[s])
-    {
-      continue;
-    }
-
-    if(currSU != firstCUInStartLCU)
-    {
-      if(!bMoveToNextLCU)
-      {
-        firstCUInStartLCU = currSU;
-      }
-      else
-      {
-        startLCU++;
-        firstCUInStartLCU = 0;
-        assert( startLCU < getNumCUsInFrame());
-      }
-      assert(startLCU*maxNumSUInLCU + firstCUInStartLCU < endAddr);
-    }
-
-
-    //2nd step: assign NonDBFilterInfo to each processing block
-    for(UInt i= startLCU; i <= endLCU; i++)
-    {
-      startSU = (i == startLCU)?(firstCUInStartLCU):(0);
-      endSU   = (i == endLCU  )?(lastCUInEndLCU   ):(maxNumSUInLCU -1);
-
-      uiAddr = m_apcPicSym->getCUOrderMap(i);
-      Int iTileID= m_apcPicSym->getTileIdxMap(uiAddr);
-
-      TComDataCU* pcCU = getCU(uiAddr);
-      m_vSliceCUDataLink[s].push_back(pcCU);
-
-      createNonDBFilterInfoLCU(iTileID, s, pcCU, startSU, endSU, m_sliceGranularityForNDBFilter, picWidth, picHeight);
-    }
-  }
-
-  //step 3: border availability
-  for(Int s=0; s< numSlices; s++)
-  {
-    if(!m_pbValidSlice[s])
-    {
-      continue;
-    }
-
-    for(Int i=0; i< m_vSliceCUDataLink[s].size(); i++)
-    {
-      TComDataCU* pcCU = m_vSliceCUDataLink[s][i];
-      uiAddr = pcCU->getAddr();
-
-      if(pcCU->getPic()==0)
-      {
-        continue;
-      }
-      Int iTileID= m_apcPicSym->getTileIdxMap(uiAddr);
-      Bool bTopTileBoundary = false, bDownTileBoundary= false, bLeftTileBoundary= false, bRightTileBoundary= false;
-
-      if(m_bIndependentTileBoundaryForNDBFilter)
-      {
-        //left
-        if( uiAddr % numLCUsInPicWidth != 0)
-        {
-          bLeftTileBoundary = ( m_apcPicSym->getTileIdxMap(uiAddr -1) != iTileID )?true:false;
-        }
-        //right
-        if( (uiAddr % numLCUsInPicWidth) != (numLCUsInPicWidth -1) )
-        {
-          bRightTileBoundary = ( m_apcPicSym->getTileIdxMap(uiAddr +1) != iTileID)?true:false;
-        }
-        //top
-        if( uiAddr >= numLCUsInPicWidth)
-        {
-          bTopTileBoundary = (m_apcPicSym->getTileIdxMap(uiAddr - numLCUsInPicWidth) !=  iTileID )?true:false;
-        }
-        //down
-        if( uiAddr + numLCUsInPicWidth < numLCUInPic )
-        {
-          bDownTileBoundary = (m_apcPicSym->getTileIdxMap(uiAddr + numLCUsInPicWidth) != iTileID)?true:false;
-        }
-
-      }
-
-      pcCU->setNDBFilterBlockBorderAvailability(numLCUsInPicWidth, numLCUsInPicHeight, maxNumSUInLCUWidth, maxNumSUInLCUHeight,picWidth, picHeight
-        , *LFCrossSliceBoundary
-        ,bTopTileBoundary, bDownTileBoundary, bLeftTileBoundary, bRightTileBoundary
-        ,m_bIndependentTileBoundaryForNDBFilter);
-
-    }
-
-  }
-
-  if( m_bIndependentSliceBoundaryForNDBFilter || m_bIndependentTileBoundaryForNDBFilter)
-  {
-    m_pNDBFilterYuvTmp = new TComPicYuv();
-#if AUXILIARY_PICTURES
-    m_pNDBFilterYuvTmp->create(picWidth, picHeight, getChromaFormat(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth);
-#else
-    m_pNDBFilterYuvTmp->create(picWidth, picHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth);
-#endif
-
-  }
-
-}
-
-/** Create non-deblocked filter information for LCU
- * \param tileID tile index
- * \param sliceID slice index
- * \param pcCU CU data pointer
- * \param startSU start SU index in LCU
- * \param endSU end SU index in LCU
- * \param sliceGranularyDepth slice granularity
- * \param picWidth picture width
- * \param picHeight picture height
- */
-Void TComPic::createNonDBFilterInfoLCU(Int tileID, Int sliceID, TComDataCU* pcCU, UInt startSU, UInt endSU, Int sliceGranularyDepth, UInt picWidth, UInt picHeight)
-{
-  UInt LCUX          = pcCU->getCUPelX();
-  UInt LCUY          = pcCU->getCUPelY();
-  Int* pCUSliceMap    = pcCU->getSliceSUMap();
-  UInt maxNumSUInLCU = getNumPartInCU();
-  UInt maxNumSUInSGU = maxNumSUInLCU >> (sliceGranularyDepth << 1);
-  UInt maxNumSUInLCUWidth = getNumPartInWidth();
-  UInt LPelX, TPelY;
-  UInt currSU;
-
-
-  //get the number of valid NBFilterBLock
-  currSU   = startSU;
-  while(currSU <= endSU)
-  {
-    LPelX = LCUX + g_auiRasterToPelX[ g_auiZscanToRaster[currSU] ];
-    TPelY = LCUY + g_auiRasterToPelY[ g_auiZscanToRaster[currSU] ];
-
-    while(!( LPelX < picWidth ) || !( TPelY < picHeight ))
-    {
-      currSU += maxNumSUInSGU;
-      if(currSU >= maxNumSUInLCU || currSU > endSU)
-      {
-        break;
-      }
-      LPelX = LCUX + g_auiRasterToPelX[ g_auiZscanToRaster[currSU] ];
-      TPelY = LCUY + g_auiRasterToPelY[ g_auiZscanToRaster[currSU] ];
-    }
-
-    if(currSU >= maxNumSUInLCU || currSU > endSU)
-    {
-      break;
-    }
-
-    NDBFBlockInfo NDBFBlock;
-
-    NDBFBlock.tileID  = tileID;
-    NDBFBlock.sliceID = sliceID;
-    NDBFBlock.posY    = TPelY;
-    NDBFBlock.posX    = LPelX;
-    NDBFBlock.startSU = currSU;
-
-    UInt uiLastValidSU  = currSU;
-    UInt uiIdx, uiLPelX_su, uiTPelY_su;
-    for(uiIdx = currSU; uiIdx < currSU + maxNumSUInSGU; uiIdx++)
-    {
-      if(uiIdx > endSU)
-      {
-        break;        
-      }
-      uiLPelX_su   = LCUX + g_auiRasterToPelX[ g_auiZscanToRaster[uiIdx] ];
-      uiTPelY_su   = LCUY + g_auiRasterToPelY[ g_auiZscanToRaster[uiIdx] ];
-      if( !(uiLPelX_su < picWidth ) || !( uiTPelY_su < picHeight ))
-      {
-        continue;
-      }
-      pCUSliceMap[uiIdx] = sliceID;
-      uiLastValidSU = uiIdx;
-    }
-    NDBFBlock.endSU = uiLastValidSU;
-
-    UInt rTLSU = g_auiZscanToRaster[ NDBFBlock.startSU ];
-    UInt rBRSU = g_auiZscanToRaster[ NDBFBlock.endSU   ];
-    NDBFBlock.widthSU  = (rBRSU % maxNumSUInLCUWidth) - (rTLSU % maxNumSUInLCUWidth)+ 1;
-    NDBFBlock.heightSU = (UInt)(rBRSU / maxNumSUInLCUWidth) - (UInt)(rTLSU / maxNumSUInLCUWidth)+ 1;
-    NDBFBlock.width    = NDBFBlock.widthSU  * getMinCUWidth();
-    NDBFBlock.height   = NDBFBlock.heightSU * getMinCUHeight();
-
-    pcCU->getNDBFilterBlocks()->push_back(NDBFBlock);
-
-    currSU += maxNumSUInSGU;
-  }
-
-}
-
-/** destroy non-deblocked filter information for LCU
- */
-Void TComPic::destroyNonDBFilterInfo()
-{
-  if(m_pbValidSlice != NULL)
-  {
-    delete[] m_pbValidSlice;
-    m_pbValidSlice = NULL;
-  }
-
-  if(m_pSliceSUMap != NULL)
-  {
-    delete[] m_pSliceSUMap;
-    m_pSliceSUMap = NULL;
-  }
-  for( UInt CUAddr = 0; CUAddr < getNumCUsInFrame() ; CUAddr++ )
-  {
-    TComDataCU* pcCU = getCU( CUAddr );
-    pcCU->getNDBFilterBlocks()->clear();
-  }
-
-  if( m_bIndependentSliceBoundaryForNDBFilter || m_bIndependentTileBoundaryForNDBFilter)
-  {
-    m_pNDBFilterYuvTmp->destroy();
-    delete m_pNDBFilterYuvTmp;
-    m_pNDBFilterYuvTmp = NULL;
-  }
-
-}
-#endif
 
 #if SVC_EXTENSION
Index: trunk/source/Lib/TLibCommon/TComPic.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPic.h	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPic.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -61,7 +61,4 @@
 private:
   UInt                  m_uiTLayer;               //  Temporal layer
-#if SVC_EXTENSION
-  UInt                  m_layerId;              //  Layer ID
-#endif
   Bool                  m_bUsedByCurr;            //  Used by current picture
   Bool                  m_bIsLongTerm;            //  IS long term picture
@@ -75,12 +72,4 @@
   Bool                  m_bNeededForOutput;
   UInt                  m_uiCurrSliceIdx;         // Index of current slice
-#if !HM_CLEANUP_SAO
-  Int*                  m_pSliceSUMap;
-  Bool*                 m_pbValidSlice;
-  Int                   m_sliceGranularityForNDBFilter;
-  Bool                  m_bIndependentSliceBoundaryForNDBFilter;
-  Bool                  m_bIndependentTileBoundaryForNDBFilter;
-  TComPicYuv*           m_pNDBFilterYuvTmp;    //!< temporary picture buffer when non-cross slice/tile boundary in-loop filtering is enabled
-#endif
   Bool                  m_bCheckLTMSB;
   
@@ -96,4 +85,5 @@
   SEIMessages  m_SEIs; ///< Any SEI messages that have been received.  If !NULL we own the object.
 #if SVC_EXTENSION
+  UInt                  m_layerId;              //  Layer ID
   Bool                  m_bSpatialEnhLayer[MAX_LAYERS];       // whether current layer is a spatial enhancement layer,
   TComPicYuv*           m_pcFullPelBaseRec[MAX_LAYERS];    // upsampled base layer recontruction for difference domain inter prediction
@@ -125,24 +115,4 @@
   UInt          getTLayer()                { return m_uiTLayer;   }
   Void          setTLayer( UInt uiTLayer ) { m_uiTLayer = uiTLayer; }
-#if SVC_EXTENSION
-  Void          setLayerId (UInt layerId) { m_layerId = layerId; }
-  UInt          getLayerId ()               { return m_layerId; }
-  Bool          isSpatialEnhLayer(UInt refLayerIdc)             { return m_bSpatialEnhLayer[refLayerIdc]; }
-  Void          setSpatialEnhLayerFlag (UInt refLayerIdc, Bool b) { m_bSpatialEnhLayer[refLayerIdc] = b; }
-  Void          setFullPelBaseRec   (UInt refLayerIdc, TComPicYuv* p) { m_pcFullPelBaseRec[refLayerIdc] = p; }
-  TComPicYuv*   getFullPelBaseRec   (UInt refLayerIdc)  { return  m_pcFullPelBaseRec[refLayerIdc];  }
-#endif
-#if REF_IDX_ME_ZEROMV || ENCODER_FAST_MODE || REF_IDX_MFM
-  Bool          isILR( UInt currLayerId )   { return ( getIsLongTerm() && m_layerId < currLayerId ); }
-#endif
-
-#if REF_IDX_MFM
-  Void          copyUpsampledMvField  ( UInt refLayerIdc, TComPic* pcPicBase );
-  Void          initUpsampledMvField  ();
-#endif
-#if MFM_ENCCONSTRAINT
-  Bool          checkSameRefInfo();
-#endif
-
   Bool          getUsedByCurr()             { return m_bUsedByCurr; }
   Void          setUsedByCurr( Bool bUsed ) { m_bUsedByCurr = bUsed; }
@@ -178,7 +148,4 @@
   
   Int           getStride()           { return m_apcPicYuv[1]->getStride(); }
-#if AUXILIARY_PICTURES
-  ChromaFormat  getChromaFormat() const { return m_apcPicYuv[1]->getChromaFormat(); }
-#endif
   Int           getCStride()          { return m_apcPicYuv[1]->getCStride(); }
   
@@ -201,20 +168,5 @@
   Window&       getDefDisplayWindow()   { return m_defaultDisplayWindow; }
 
-#if HM_CLEANUP_SAO
   Bool          getSAOMergeAvailability(Int currAddr, Int mergeAddr);
-#else
-  Void          createNonDBFilterInfo   (std::vector<Int> sliceStartAddress, Int sliceGranularityDepth
-                                        ,std::vector<Bool>* LFCrossSliceBoundary
-                                        ,Int  numTiles = 1
-                                        ,Bool bNDBFilterCrossTileBoundary = true);
-  Void          createNonDBFilterInfoLCU(Int tileID, Int sliceID, TComDataCU* pcCU, UInt startSU, UInt endSU, Int sliceGranularyDepth, UInt picWidth, UInt picHeight);
-  Void          destroyNonDBFilterInfo();
-
-  Bool          getValidSlice                                  (Int sliceID)  {return m_pbValidSlice[sliceID];}
-  Bool          getIndependentSliceBoundaryForNDBFilter        ()             {return m_bIndependentSliceBoundaryForNDBFilter;}
-  Bool          getIndependentTileBoundaryForNDBFilter         ()             {return m_bIndependentTileBoundaryForNDBFilter; }
-  TComPicYuv*   getYuvPicBufferForIndependentBoundaryProcessing()             {return m_pNDBFilterYuvTmp;}
-  std::vector<TComDataCU*>& getOneSliceCUDataForNDBFilter      (Int sliceID) { return m_vSliceCUDataLink[sliceID];}
-#endif
 
   /* field coding parameters*/
@@ -239,4 +191,23 @@
 
 #if SVC_EXTENSION
+  Void          setLayerId (UInt layerId) { m_layerId = layerId; }
+  UInt          getLayerId ()               { return m_layerId; }
+  Bool          isSpatialEnhLayer(UInt refLayerIdc)             { return m_bSpatialEnhLayer[refLayerIdc]; }
+  Void          setSpatialEnhLayerFlag (UInt refLayerIdc, Bool b) { m_bSpatialEnhLayer[refLayerIdc] = b; }
+  Void          setFullPelBaseRec   (UInt refLayerIdc, TComPicYuv* p) { m_pcFullPelBaseRec[refLayerIdc] = p; }
+  TComPicYuv*   getFullPelBaseRec   (UInt refLayerIdc)  { return  m_pcFullPelBaseRec[refLayerIdc];  }
+#if REF_IDX_ME_ZEROMV || ENCODER_FAST_MODE || REF_IDX_MFM
+  Bool          isILR( UInt currLayerId )   { return ( getIsLongTerm() && m_layerId < currLayerId ); }
+#endif
+#if REF_IDX_MFM
+  Void          copyUpsampledMvField  ( UInt refLayerIdc, TComPic* pcPicBase );
+  Void          initUpsampledMvField  ();
+#endif
+#if MFM_ENCCONSTRAINT
+  Bool          checkSameRefInfo();
+#endif
+#if AUXILIARY_PICTURES
+  ChromaFormat  getChromaFormat() const { return m_apcPicYuv[1]->getChromaFormat(); }
+#endif
   Void  copyUpsampledPictureYuv(TComPicYuv*   pcPicYuvIn, TComPicYuv*   pcPicYuvOut); 
 #if AVC_SYNTAX
Index: trunk/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -67,7 +67,5 @@
 ,m_puiTileIdxMap(NULL)
 ,m_puiInverseCUOrderMap(NULL)
-#if HM_CLEANUP_SAO
 ,m_saoBlkParams(NULL)
-#endif
 {};
 
@@ -131,9 +129,5 @@
   }
 
-#if HM_CLEANUP_SAO
   m_saoBlkParams = new SAOBlkParam[m_uiNumCUsInFrame];
-#else
-  m_saoParam = NULL;
-#endif
 }
 
@@ -191,17 +185,8 @@
   m_puiInverseCUOrderMap = NULL;
   
-#if HM_CLEANUP_SAO
   if(m_saoBlkParams)
   {
     delete[] m_saoBlkParams; m_saoBlkParams = NULL;
   }
-#else
-  if (m_saoParam)
-  {
-    TComSampleAdaptiveOffset::freeSaoParam(m_saoParam);
-    delete m_saoParam;
-    m_saoParam = NULL;
-  }
-#endif
 }
 
@@ -347,6 +332,4 @@
 }
 
-
-#if HM_CLEANUP_SAO
 Void TComPicSym::deriveLoopFilterBoundaryAvailibility(Int ctu,
                                                       Bool& isLeftAvail,
@@ -419,10 +402,10 @@
       if(ctuAboveRigtht != NULL)
       {
-        Int curSliceStartTS  = getCUOrderMap(ctuCurr->getSlice()->getSliceCurStartCUAddr()/m_uiNumPartitions);
-        Int aboveRigthtSliceStartTS = getCUOrderMap(ctuAboveRigtht->getSlice()->getSliceCurStartCUAddr()/m_uiNumPartitions);
-
-        isAboveRightAvail = (curSliceStartTS == aboveRigthtSliceStartTS)?(true):
+        Int curSliceStartEncOrder  = ctuCurr->getSlice()->getSliceCurStartCUAddr();
+        Int aboveRigthtSliceStartEncOrder = ctuAboveRigtht->getSlice()->getSliceCurStartCUAddr();
+
+        isAboveRightAvail = (curSliceStartEncOrder == aboveRigthtSliceStartEncOrder)?(true):
           (
-          (curSliceStartTS > aboveRigthtSliceStartTS)?(ctuCurr->getSlice()->getLFCrossSliceBoundaryFlag())
+          (curSliceStartEncOrder > aboveRigthtSliceStartEncOrder)?(ctuCurr->getSlice()->getLFCrossSliceBoundaryFlag())
           :(ctuAboveRigtht->getSlice()->getLFCrossSliceBoundaryFlag())
           );          
@@ -431,10 +414,10 @@
       if(ctuBelowLeft != NULL)
       {
-        Int curSliceStartTS       = getCUOrderMap(ctuCurr->getSlice()->getSliceCurStartCUAddr()/m_uiNumPartitions);
-        Int belowLeftSliceStartTS = getCUOrderMap(ctuBelowLeft->getSlice()->getSliceCurStartCUAddr()/m_uiNumPartitions);
-
-        isBelowLeftAvail = (curSliceStartTS == belowLeftSliceStartTS)?(true):
+        Int curSliceStartEncOrder  = ctuCurr->getSlice()->getSliceCurStartCUAddr();
+        Int belowLeftSliceStartEncOrder = ctuBelowLeft->getSlice()->getSliceCurStartCUAddr();
+
+        isBelowLeftAvail = (curSliceStartEncOrder == belowLeftSliceStartEncOrder)?(true):
           (
-          (curSliceStartTS > belowLeftSliceStartTS)?(ctuCurr->getSlice()->getLFCrossSliceBoundaryFlag())
+          (curSliceStartEncOrder > belowLeftSliceStartEncOrder)?(ctuCurr->getSlice()->getLFCrossSliceBoundaryFlag())
           :(ctuBelowLeft->getSlice()->getLFCrossSliceBoundaryFlag())
           );
@@ -456,11 +439,4 @@
 
 }
-#else
-Void TComPicSym::allocSaoParam(TComSampleAdaptiveOffset *sao)
-{
-  m_saoParam = new SAOParam;
-  sao->allocSaoParam(m_saoParam);
-}
-#endif
 
 TComTile::TComTile()
Index: trunk/source/Lib/TLibCommon/TComPicSym.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicSym.h	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPicSym.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -105,4 +105,9 @@
   UInt*         m_puiCUOrderMap;       //the map of LCU raster scan address relative to LCU encoding order 
   UInt*         m_puiTileIdxMap;       //the map of the tile index relative to LCU raster scan address 
+  UInt*         m_puiInverseCUOrderMap;
+
+  SAOBlkParam *m_saoBlkParams;
+
+#if SVC_EXTENSION
 #if N0383_IL_CONSTRAINED_TILE_SETS_SEI
   Int*          m_piTileSetIdxMap;     //the map of the tile set index relative to LCU raster scan address
@@ -110,10 +115,4 @@
   Bool*         m_pbSkippedTileSetFlag;
 #endif
-  UInt*         m_puiInverseCUOrderMap;
-
-#if HM_CLEANUP_SAO
-  SAOBlkParam *m_saoBlkParams;
-#else
-  SAOParam *m_saoParam;
 #endif
 
@@ -130,15 +129,4 @@
   UInt        getNumberOfCUsInFrame()   { return m_uiNumCUsInFrame;  }
   TComDataCU*&  getCU( UInt uiCUAddr )  { return m_apcTComDataCU[uiCUAddr];     }
-  
-#if LAYER_CTB
-  UInt        getMaxCUWidth()           { return m_uiMaxCUWidth;                }
-  UInt        getMaxCUHeight()          { return m_uiMaxCUHeight;               }
-#endif
-
-#if AVC_SYNTAX
-  UInt        getMaxCUWidth()           { return m_uiMaxCUWidth;                }
-  UInt        getMaxCUHeight()          { return m_uiMaxCUHeight;               }
-  UInt        getMaxDepth()             { return m_uhTotalDepth;               }
-#endif
   
   Void        setSlice(TComSlice* p, UInt i) { m_apcTComSlice[i] = p;           }
@@ -158,4 +146,24 @@
   UInt         getCUOrderMap( Int encCUOrder )                       { return *(m_puiCUOrderMap + (encCUOrder>=m_uiNumCUsInFrame ? m_uiNumCUsInFrame : encCUOrder)); }
   UInt         getTileIdxMap( Int i )                                { return *(m_puiTileIdxMap + i); }
+  Void         setInverseCUOrderMap( Int cuAddr, Int encCUOrder )    { *(m_puiInverseCUOrderMap + cuAddr) = encCUOrder; }
+  UInt         getInverseCUOrderMap( Int cuAddr )                    { return *(m_puiInverseCUOrderMap + (cuAddr>=m_uiNumCUsInFrame ? m_uiNumCUsInFrame : cuAddr)); }
+  UInt         getPicSCUEncOrder( UInt SCUAddr );
+  UInt         getPicSCUAddr( UInt SCUEncOrder );
+  Void         xCreateTComTileArray();
+  Void         xInitTiles();
+  UInt         xCalculateNxtCUAddr( UInt uiCurrCUAddr );
+  SAOBlkParam* getSAOBlkParam() { return m_saoBlkParams;}
+  Void deriveLoopFilterBoundaryAvailibility(Int ctu, Bool& isLeftAvail,Bool& isRightAvail,Bool& isAboveAvail,Bool& isBelowAvail,Bool& isAboveLeftAvail,Bool& isAboveRightAvail,Bool& isBelowLeftAvail,Bool& isBelowRightAvail);
+
+#if SVC_EXTENSION
+#if LAYER_CTB
+  UInt        getMaxCUWidth()           { return m_uiMaxCUWidth;                }
+  UInt        getMaxCUHeight()          { return m_uiMaxCUHeight;               }
+#endif
+#if AVC_SYNTAX
+  UInt        getMaxCUWidth()           { return m_uiMaxCUWidth;                }
+  UInt        getMaxCUHeight()          { return m_uiMaxCUHeight;               }
+  UInt        getMaxDepth()             { return m_uhTotalDepth;               }
+#endif
 #if N0383_IL_CONSTRAINED_TILE_SETS_SEI
   Void         setTileSetIdxMap( Int i, Int tileSetIdx, UChar setType, Bool skipFlag )
@@ -169,20 +177,5 @@
   Bool         getSkippedTileSetFlag( Int i )                        { return *(m_pbSkippedTileSetFlag + i); }
 #endif
-  Void         setInverseCUOrderMap( Int cuAddr, Int encCUOrder )    { *(m_puiInverseCUOrderMap + cuAddr) = encCUOrder; }
-  UInt         getInverseCUOrderMap( Int cuAddr )                    { return *(m_puiInverseCUOrderMap + (cuAddr>=m_uiNumCUsInFrame ? m_uiNumCUsInFrame : cuAddr)); }
-  UInt         getPicSCUEncOrder( UInt SCUAddr );
-  UInt         getPicSCUAddr( UInt SCUEncOrder );
-  Void         xCreateTComTileArray();
-  Void         xInitTiles();
-  UInt         xCalculateNxtCUAddr( UInt uiCurrCUAddr );
-#if HM_CLEANUP_SAO
-  SAOBlkParam* getSAOBlkParam() { return m_saoBlkParams;}
-  Void deriveLoopFilterBoundaryAvailibility(Int ctu, Bool& isLeftAvail,Bool& isRightAvail,Bool& isAboveAvail,Bool& isBelowAvail,Bool& isAboveLeftAvail,Bool& isAboveRightAvail,Bool& isBelowLeftAvail,Bool& isBelowRightAvail);
-#else
-  Void allocSaoParam(TComSampleAdaptiveOffset *sao);
-  SAOParam *getSaoParam() { return m_saoParam; }
-#endif
-
-
+#endif //SVC_EXTENSION
 };// END CLASS DEFINITION TComPicSym
 
Index: trunk/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -75,7 +75,4 @@
   Int   m_iPicWidth;            ///< Width of picture
   Int   m_iPicHeight;           ///< Height of picture
-#if AUXILIARY_PICTURES
-  ChromaFormat m_chromaFormatIDC; ////< Chroma Format
-#endif
   
   Int   m_iCuWidth;             ///< Width of Coding Unit (CU)
@@ -91,13 +88,17 @@
   Int   m_iChromaMarginY;
   
+  Bool  m_bIsBorderExtended;
+
+#if SVC_EXTENSION
+#if AUXILIARY_PICTURES
+  ChromaFormat m_chromaFormatIDC; ////< Chroma Format
+#endif
 #if SVC_UPSAMPLING
   Window  m_conformanceWindow;
 #endif
-
 #if M0040_ADAPTIVE_RESOLUTION_CHANGE
   Bool    m_isReconstructed;
 #endif
-
-  Bool  m_bIsBorderExtended;
+#endif //SVC_EXTENSION
   
 protected:
@@ -136,11 +137,4 @@
   Int   getWidth    ()     { return  m_iPicWidth;    }
   Int   getHeight   ()     { return  m_iPicHeight;   }
-#if AUXILIARY_PICTURES
-  ChromaFormat  getChromaFormat   ()                     const { return m_chromaFormatIDC; }
-#endif
-  
-#if SVC_EXTENSION
-  Void   setHeight   ( Int iPicHeight )     { m_iPicHeight = iPicHeight; }
-#endif
 
   Int   getStride   ()     { return (m_iPicWidth     ) + (m_iLumaMarginX  <<1); }
@@ -172,9 +166,4 @@
   Pel*  getCrAddr   ( Int iCuAddr, Int uiAbsZorderIdx ) { return m_piPicOrgV + m_cuOffsetC[iCuAddr] + m_buOffsetC[g_auiZscanToRaster[uiAbsZorderIdx]]; }
   
-#if SVC_UPSAMPLING
-  Window& getConformanceWindow()                           { return  m_conformanceWindow;             }
-  Void    setConformanceWindow(Window& conformanceWindow ) { m_conformanceWindow = conformanceWindow; }
-#endif
-
   // ------------------------------------------------------------------------------------------------
   //  Miscellaneous
@@ -193,15 +182,23 @@
   Void  dump (Char* pFileName, Bool bAdd = false);
 
+  // Set border extension flag
+  Void  setBorderExtension(Bool b) { m_bIsBorderExtended = b; }
+  
+#if SVC_EXTENSION
+  Void   setHeight   ( Int iPicHeight )     { m_iPicHeight = iPicHeight; }
+#if SVC_UPSAMPLING
+  Window& getConformanceWindow()                           { return  m_conformanceWindow;             }
+  Void    setConformanceWindow(Window& conformanceWindow ) { m_conformanceWindow = conformanceWindow; }
+#endif
 #if M0040_ADAPTIVE_RESOLUTION_CHANGE
   Void  setReconstructed(Bool x) { m_isReconstructed = x;    }
   Bool  isReconstructed()        { return m_isReconstructed; }
 #endif
-
 #if AUXILIARY_PICTURES
+  ChromaFormat  getChromaFormat   ()                     const { return m_chromaFormatIDC; }
   Void convertToMonochrome();
 #endif
-
-  // Set border extension flag
-  Void  setBorderExtension(Bool b) { m_bIsBorderExtended = b; }
+#endif //SVC_EXTENSION
+
 };// END CLASS DEFINITION TComPicYuv
 
Index: trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -408,4 +408,5 @@
 }
 
+
 Void TComPrediction::motionCompensation ( TComDataCU* pcCU, TComYuv* pcYuvPred, RefPicList eRefPicList, Int iPartIdx )
 {
Index: trunk/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 588)
+++ trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -410,6 +410,8 @@
     }
   }
-  else if ( ( (iWidth % 4) == 0 ) && ( (iHeight % 4) == 0 ) )
-  {
+  else
+  {
+    assert(iWidth % 4 == 0 && iHeight % 4 == 0);
+    
     for ( y=0; y<iHeight; y+= 4 )
     {
@@ -420,16 +422,4 @@
       pi0 += iStride0*4;
       pi1 += iStride1*4;
-    }
-  }
-  else
-  {
-    for ( y=0; y<iHeight; y+= 2 )
-    {
-      for ( x=0; x<iWidth; x+= 2 )
-      {
-        uiSum += xCalcHADs8x8( &pi0[x], &pi1[x], iStride0, iStride1, 1 );
-      }
-      pi0 += iStride0*2;
-      pi1 += iStride1*2;
     }
   }
